`timescale 1ns / 1ps
//////////////////////////////////////////////////////////////////////////////////
// Company: 
// Engineer: 
// 
// Create Date:    15:08:17 09/08/2016 
// Design Name: 
// Module Name:    ovf_keeper 
// Project Name: 
// Target Devices: 
// Tool versions: 
// Description: 
//
// Dependencies: 
//
// Revision: 
// Revision 0.01 - File Created
// Additional Comments: 
//
//////////////////////////////////////////////////////////////////////////////////
module ovf_keeper(
    input fft_ovf_in,
    input int_ovf_in,
    input aclk,
    input aresetn,
    output reg [3:0]ovf_out
    );

    reg [31:0] counter_n = 32'h00000000;
    /*****************************************************************************/
    /* MAIN CODE */
    /*****************************************************************************/
    always @(posedge aclk)
	 //always @(negedge aclk or negedge aresetn_in)
	 begin
        if (!aresetn)
		    begin
            counter_n <= 32'h00000000;//is reset
				ovf_out[3:0] <= 4'd0;
          end
		  else
		    begin
          if (fft_ovf_in || int_ovf_in)
		      begin
              counter_n <= 32'hFFFFFFFF;//is reset
				  ovf_out[3:0] <= {(int_ovf_in | ovf_out[3]), (fft_ovf_in | ovf_out[2]), int_ovf_in, fft_ovf_in};
            end
		    else
            if (counter_n)
              counter_n <= counter_n - 1;//not reset
		      else
				  if (ovf_out[1:0])
		            ovf_out[1:0] <= 2'b00;
			 end
	 end
endmodule
