`timescale 1ns / 1ps
//////////////////////////////////////////////////////////////////////////////////
// Company: 
// Engineer: 
// 
// Create Date:    13:33:19 10/05/2016 
// Design Name: 
// Module Name:    self_reset 
// Project Name: 
// Target Devices: 
// Tool versions: 
// Description: 
//
// Dependencies: 
//
// Revision: 
// Revision 0.01 - File Created
// Additional Comments: 
//
//////////////////////////////////////////////////////////////////////////////////
`timescale 1ns / 1ps
//////////////////////////////////////////////////////////////////////////////////
// Company: 
// Engineer: 
// 
// Create Date:    12:53:21 08/04/2015 
// Design Name: 
// Module Name:    async_reset2 
// Project Name: 
// Target Devices: 
// Tool versions: 
// Description: 
//
// Dependencies: 
//
// Revision: 
// Revision 0.01 - File Created
// Additional Comments: 
//
//////////////////////////////////////////////////////////////////////////////////
module self_reset(
    input aresetn_in,
    input aclk,
    input aresetn_eti,
    output aresetn_out
    );

    reg [7:0] reset_sync_n = 8'h00;
	 reg fisrst_time_reset = 1'b1;
	 reg aresetn_eti_prev = 1'b1;
    /*****************************************************************************/
    /* MAIN CODE */
    /*****************************************************************************/
    always @(posedge aclk or negedge aresetn_in)
	 //always @(negedge aclk or negedge aresetn_in)
	 begin
        if (!aresetn_in) begin
            reset_sync_n <= 8'h00;//is reset
				fisrst_time_reset <= 1'b1;
				aresetn_eti_prev <= 1'b1;
		  end else begin
				reset_sync_n <= {reset_sync_n[6:0], 1'b1};//not reset
				// count 8 cycles delay, where we are not able to do reset

				if (aresetn_out == 1'b1 &&
					 aresetn_eti_prev != aresetn_eti && //we have event from eti-parser
					 aresetn_eti == 1'b1 //is this event ended?
					 ) begin
						
					if(fisrst_time_reset)
						fisrst_time_reset <= 1'b0;
					else begin
						fisrst_time_reset <= 1'b1;//first reset is own module's init
						reset_sync_n <= 8'h00;
					end
				end
				aresetn_eti_prev <= aresetn_eti;
			end
	 end

    assign aresetn_out = reset_sync_n[7];

endmodule
